Subject: Re: [PATCH v2 net] ip6_gre: use skb_vlan_inet_prepare() instead of pskb_inet_may_pull()

From: Simon Horman <[email-masked]>
Date: Mon, 12 Jan 2026 13:58:33 +0000

On Wed, Jan 07, 2026 at 10:01:22AM +0100, Eric Dumazet wrote:
> On Wed, Jan 7, 2026 at 9:46 AM Florian Westphal <[email-masked]> wrote:
> >
> > Eric Dumazet <[email-masked]> wrote:
> > > On Tue, Jan 6, 2026 at 6:56 PM Jakub Kicinski <[email-masked]> wrote:
> > > >
> > > > On Tue,  6 Jan 2026 14:45:29 +0000 Eric Dumazet wrote:
> > > > > v2: invert the conditions (Jakub)
> > > >
> > > > Thanks! Much better now, but still failing
> > > > tools/testing/selftests/net/gre_gso.sh
> > > >
> > > > TAP version 13
> > > > 1..1
> > > > # timeout set to 3600
> > > > # selftests: net: gre_gso.sh
> > > > # 2.16 [+2.16]     TEST: GREv6/v4 - copy file w/ TSO                                   [ OK ]
> > > > # 3.16 [+1.01] 2026/01/06 10:32:57 socat[20546] W exiting on signal 15
> > > > # 3.17 [+0.01] 2026/01/06 10:32:57 socat[20546] W exiting on signal 15
> > > > # 3.17 [+0.00]     TEST: GREv6/v4 - copy file w/ GSO                                   [FAIL]
> > > > # 3.18 [+0.01] 2026/01/06 10:32:57 socat[20533] W exiting on signal 15
> > > > # 3.19 [+0.00]     TEST: GREv6/v6 - copy file w/ TSO                                   [ OK ]
> > > > # 4.19 [+1.00] 2026/01/06 10:32:59 socat[20559] W exiting on signal 15
> > > > # 4.19 [+0.01]     TEST: GREv6/v6 - copy file w/ GSO                                   [FAIL]
> > > > # 4.20 [+0.01] 2026/01/06 10:32:59 socat[20549] W exiting on signal 15
> > > > # 4.22 [+0.02] 2026/01/06 10:32:59 socat[20560] W exiting on signal 15
> > > > # 4.23 [+0.01]
> > > > # 4.23 [+0.00] Tests passed:   2
> > > > # 4.23 [+0.00] Tests failed:   2
> > > > not ok 1 selftests: net: gre_gso.sh # exit=1
> > > >
> > > > https://netdev-ctrl.bots.linux.dev/logs/vmksft/net/results/461862/65-gre-gso-sh/stdout
> > >
> > > For some reason I am unable to run this test from a virtme-ng instance.
> > >
> > > I guess I wlll not make a new version of this patch, maybe Florian can
> > > take over.
> >
> > Its failing because nhoff is moved by 14 bytes, test passes after doing:
> >
> > -       if (skb_vlan_inet_prepare(skb, false))
> > +       if (skb_vlan_inet_prepare(skb, true))
> 
> Thanks Florian.
> 
> I finally understood that my virtme-ng problem with this test is that
> on my platform, /proc/sys/net/core/fb_tunnels_only_for_init_net was
> set to 2
> 
> Tests have a hidden dependency against this sysctl.

Should unhide it by making the tests check or set this value?

It seems like a lot of time was lost on this already.